## bespokesynth 1.2.1%2Bdfsg

=== debian/control ===
Source: bespokesynth
Section: sound
Priority: optional
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
Uploaders:
 Andrius Merkys <merkys@debian.org>,
Rules-Requires-Root: no
Build-Depends:
 ableton-link-dev,
 cmake,
 debhelper-compat (= 13),
 juce-modules-source,
 libjack-dev,
 libjsoncpp-dev,
 libmts-esp-dev,
 libpython3-dev,
 libreaderwriterqueue-dev,
 libtuning-library-dev,
 pybind11-dev,
Standards-Version: 4.6.2
Homepage: https://github.com/BespokeSynth/BespokeSynth
Vcs-Git: https://salsa.debian.org/multimedia-team/bespokesynth.git
Vcs-Browser: https://salsa.debian.org/multimedia-team/bespokesynth

Package: bespokesynth
Architecture: any
Multi-Arch: foreign
Depends:
 bespokesynth-data,
 fonts-freefont-ttf,
 ${misc:Depends},
 ${shlibs:Depends},
Description: software modular synthesizer
 Bespoke is a software modular synthesizer. It contains an array of modules,
 which one can connect together to create sounds. Bespoke is like a digital
 audio workstation in some ways, but with less of a focus on a global timeline.
 Instead, it has a design more optimized for jamming and exploration.

Package: bespokesynth-data
Architecture: all
Depends:
 ${misc:Depends},
Description: software modular synthesizer - data files
 Bespoke is a software modular synthesizer. It contains an array of modules,
 which one can connect together to create sounds. Bespoke is like a digital
 audio workstation in some ways, but with less of a focus on a global timeline.
 Instead, it has a design more optimized for jamming and exploration.
 .
 This package contains Bespoke data files.

## bespokesynth 1.2.1+dfsg

=== CMakeLists.txt ===
cmake_minimum_required(VERSION 3.16)
cmake_policy(SET CMP0091 NEW)

# Global build parameters. Optional features are configurable via additional
# BESPOKE_* variables defined in their respective subdirs.
option(BESPOKE_NIGHTLY "Automated build from github" OFF)
option(BESPOKE_PORTABLE "Create a self-contained build that ships all dependencies" OFF)
set(BESPOKE_JUCE_LOCATION "${CMAKE_SOURCE_DIR}/libs/JUCE" CACHE STRING "Path to JUCE library source tree")
set(BESPOKE_PYTHON_ROOT "" CACHE STRING "Python search path. Override as needed.")
set(BESPOKE_VST2_SDK_LOCATION "" CACHE STRING "Steinberg VST2 SDK directory for non-FOSS builds")
set(BESPOKE_ASIO_SDK_LOCATION "" CACHE STRING "Steinberg ASIO SDK directory for non-FOSS builds")
set(BESPOKE_SPACEMOUSE_SDK_LOCATION "" CACHE STRING "3Dxware SpaceMouse SDK directory for non-FOSS builds")
option(BESPOKE_SYSTEM_JUCE "Use system installation of juce" OFF)
option(BESPOKE_DEVENDORED_SYSTEM_JUCE "Use system libraries when using system installation of juce" OFF)
option(BESPOKE_SYSTEM_PYBIND11 "Use a system installation of pybind11" OFF)
option(BESPOKE_SYSTEM_JSONCPP "Use system-wide installation of jsoncpp" OFF)
option(BESPOKE_SYSTEM_TUNING_LIBRARY "Use system installation of tuning-library" OFF)
option(BESPOKE_USE_ASAN "Build with ASAN" OFF)

# Global CMake options
set(CMAKE_EXPORT_COMPILE_COMMANDS ON) # clangd/LSP support
set(CMAKE_CXX_EXTENSIONS OFF)
set(CMAKE_CXX_STANDARD 17)
set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
set_property(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" PROPERTY VS_STARTUP_PROJECT BespokeSynth)
set(CMAKE_OSX_DEPLOYMENT_TARGET 10.11 CACHE STRING "Minimum macOS version")
set(CMAKE_POSITION_INDEPENDENT_CODE ON)
if (NOT CMAKE_BUILD_TYPE)
    set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
endif ()

project(BespokeSynth VERSION 1.2.1 LANGUAGES C CXX ASM)

message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
math(EXPR BESPOKE_BITNESS "${CMAKE_SIZEOF_VOID_P} * 8" OUTPUT_FORMAT DECIMAL)
message(STATUS "Targeting ${BESPOKE_BITNESS} bit configuration")

# Global compile options
add_compile_options(
    # Build with Multiple Processes on Visual Studio
    $<$<CXX_COMPILER_ID:MSVC>:/MP>
    # Set source and executable charsets to UTF-8. Required for building on CJK Windows.
    $<$<CXX_COMPILER_ID:MSVC>:/utf-8>
    )

set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")

if(WIN32 AND ${BESPOKE_BITNESS} EQUAL 32)
    add_link_options(
        # Windows 32-bit: Extended address space
        $<$<CXX_COMPILER_ID:MSVC>:/LARGEADDRESSAWARE>
        $<$<BOOL:${MINGW}>:LINKER:--large-address-aware>
        )
endif()

if (BESPOKE_USE_ASAN)
    message( STATUS "BUILDING with ASAN" )
    add_compile_options(-fsanitize=address -fno-omit-frame-pointer)
    add_link_options(-fsanitize=address)
endif()

if(BESPOKE_NIGHTLY)
    message(STATUS "Nightly build")
endif()

if(BESPOKE_PORTABLE)
    message(STATUS "Portable build enabled")
    if(MINGW)
        message(WARNING "Portable MinGW builds don't ship the runtime DLLs \
        (libgcc_s_seh-1.dll, libstdc++-6.dll, libwinpthread-1.dll). Make sure \
        to copy them to the .exe's directory before distributing this build.")
    endif()
endif()

if(BESPOKE_PYTHON_ROOT)
    set(Python_ROOT "${BESPOKE_PYTHON_ROOT}")
    message(STATUS "Overriding Python_ROOT to ${Python_ROOT}")
endif()
find_package (Python 3.6 COMPONENTS Interpreter Development REQUIRED)
message(STATUS "Python version: ${Python_VERSION}")
message(STATUS "Python executable: ${Python_EXECUTABLE}")
message(STATUS "Python library: ${Python_LIBRARIES}")

if(NOT BESPOKE_SYSTEM_JUCE)
  message(STATUS "Using JUCE from ${BESPOKE_JUCE_LOCATION}")
  add_subdirectory(${BESPOKE_JUCE_LOCATION} ${CMAKE_BINARY_DIR}/JUCE EXCLUDE_FROM_ALL)
else()
  message(STATUS "Using system provided JUCE")
  find_package(JUCE COMPONENTS REQUIRED)
  if(BESPOKE_DEVENDORED_SYSTEM_JUCE)
    message(STATUS "Using devendored system provided JUCE")
    include(FindPkgConfig)
    pkg_search_module(flac REQUIRED flac)
    pkg_search_module(ogg REQUIRED ogg)
    pkg_search_module(vorbis REQUIRED vorbis vorbisenc vorbisfile)
  endif()
endif()

if (BESPOKE_VST2_SDK_LOCATION)
    juce_set_vst2_sdk_path(${BESPOKE_VST2_SDK_LOCATION})
    message(STATUS "Enabling VST2 - caution, non FOSS build")
endif()

add_subdirectory(libs)
add_subdirectory(Source)

=== Source/CMakeLists.txt ===
include(cmake/lib.cmake)
include(cmake/versiontools.cmake)
include(../libs/ableton-link/AbletonLinkConfig.cmake)

juce_add_gui_app(BespokeSynth
    PRODUCT_NAME BespokeSynth
    ICON_BIG ${CMAKE_SOURCE_DIR}/bespoke_icon.png
    MICROPHONE_PERMISSION_ENABLED TRUE
    CAMERA_PERMISSION_ENABLED     TRUE
    BLUETOOTH_PERMISSION_ENABLED  TRUE
    FILE_SHARING_ENABLED          TRUE
    DOCUMENT_BROWSER_ENABLED      TRUE
    DOCUMENT_EXTENSIONS           .bsk
    BUNDLE_ID                     com.ryanchallinor.bespokesynth
    PLUGINHOST_AU                 TRUE
    )

bespoke_buildtime_version_info(BespokeSynth)

target_sources(BespokeSynth PRIVATE
    ADSR.cpp
    ADSR.h
    ADSRDisplay.cpp
    ADSRDisplay.h
    AbletonLink.cpp
    AbletonLink.h
    Amplifier.cpp
    Amplifier.h
    Arpeggiator.cpp
    Arpeggiator.h
    ArrangementController.cpp
    ArrangementController.h
    AudioLevelToCV.cpp
    AudioLevelToCV.h
    AudioMeter.cpp
    AudioMeter.h
    AudioRouter.cpp
    AudioRouter.h
    AudioSend.cpp
    AudioSend.h
    AudioToCV.cpp
    AudioToCV.h
    AudioToPulse.cpp
    AudioToPulse.h
    Autotalent.cpp
    Autotalent.h
    BandVocoder.cpp
    BandVocoder.h
    BeatBloks.cpp
    BeatBloks.h
    Beats.cpp
    Beats.h
    BiquadFilter.cpp
    BiquadFilter.h
    BiquadFilterEffect.cpp
    BiquadFilterEffect.h
    BitcrushEffect.cpp
    BitcrushEffect.h
    BufferShuffler.cpp
    BufferShuffler.h
    ButterworthFilterEffect.cpp
    ButterworthFilterEffect.h
    Canvas.cpp
    Canvas.h
    CanvasControls.cpp
    CanvasControls.h
    CanvasElement.cpp
    CanvasElement.h
    CanvasScrollbar.cpp
    CanvasScrollbar.h
    CanvasTimeline.cpp
    CanvasTimeline.h
    Capo.cpp
    Capo.h
    ChannelBuffer.cpp
    ChannelBuffer.h
    ChaosEngine.cpp
    ChaosEngine.h
    Checkbox.cpp
    Checkbox.h
    Chord.cpp
    Chord.h
    ChordDatabase.cpp
    ChordDatabase.h
    ChordDisplayer.cpp
    ChordDisplayer.h
    ChordHolder.cpp
    ChordHolder.h
    Chorder.cpp
    Chorder.h
    CircleSequencer.cpp
    CircleSequencer.h
    ClickButton.cpp
    ClickButton.h
    ClipArranger.cpp
    ClipArranger.h
    ClipLauncher.cpp
    ClipLauncher.h
    CodeEntry.cpp
    CodeEntry.h
    ComboGridController.cpp
    ComboGridController.h
    CommentDisplay.cpp
    CommentDisplay.h
    Compressor.cpp
    Compressor.h
    ControlSequencer.cpp
    ControlSequencer.h
    ControlTactileFeedback.cpp
    ControlTactileFeedback.h
    ControllingSong.cpp
    ControllingSong.h
    Curve.cpp
    Curve.h
    CurveLooper.cpp
    CurveLooper.h
    DCOffset.cpp
    DCOffset.h
    DCRemoverEffect.cpp
    DCRemoverEffect.h
    DebugAudioSource.cpp
    DebugAudioSource.h
    DelayEffect.cpp
    DelayEffect.h
    DistortionEffect.cpp
    DistortionEffect.h
    DropdownList.cpp
    DropdownList.h
    DrumPlayer.cpp
    DrumPlayer.h
    DrumSynth.cpp
    DrumSynth.h
    EQEffect.cpp
    EQEffect.h
    EQModule.cpp
    EQModule.h
    EffectChain.cpp
    EffectChain.h
    EffectFactory.cpp
    EffectFactory.h
    EnvOscillator.cpp
    EnvOscillator.h
    EnvelopeEditor.cpp
    EnvelopeEditor.h
    EnvelopeModulator.cpp
    EnvelopeModulator.h
    EventCanvas.cpp
    EventCanvas.h
    FFT.cpp
    FFT.h
    FFTtoAdditive.cpp
    FFTtoAdditive.h
    FMSynth.cpp
    FMSynth.h
    FMVoice.cpp
    FMVoice.h
    FeedbackModule.cpp
    FeedbackModule.h
    FileStream.cpp
    FileStream.h
    FillSaveDropdown.h
    FilterButterworth24db.cpp
    FilterButterworth24db.h
    FilterViz.cpp
    FilterViz.h
    FloatSliderLFOControl.cpp
    FloatSliderLFOControl.h
    FollowingSong.cpp
    FollowingSong.h
    FormantFilterEffect.cpp
    FormantFilterEffect.h
    FourOnTheFloor.cpp
    FourOnTheFloor.h
    FreeverbEffect.cpp
    FreeverbEffect.h
    FreqDelay.cpp
    FreqDelay.h
    FreqDomainBoilerplate.cpp
    FreqDomainBoilerplate.h
    FubbleModule.cpp
    FubbleModule.h
    GainStageEffect.cpp
    GainStageEffect.h
    GateEffect.cpp
    GateEffect.h
    GlobalControls.cpp
    GlobalControls.h
    Granulator.cpp
    Granulator.h
    GridController.cpp
    GridController.h
    GridModule.cpp
    GridModule.h
    GridSliders.cpp
    GridSliders.h
    GroupControl.cpp
    GroupControl.h
    HelpDisplay.cpp
    HelpDisplay.h
    IAudioEffect.h
    IAudioPoller.h
    IAudioProcessor.cpp
    IAudioProcessor.h
    IAudioReceiver.cpp
    IAudioReceiver.h
    IAudioSource.cpp
    IAudioSource.h
    IClickable.cpp
    IClickable.h
    IDrawableModule.cpp
    IDrawableModule.h
    IDrivableSequencer.h
    IMidiVoice.h
    IModulator.cpp
    IModulator.h
    INonstandardController.h
    INoteReceiver.cpp
    INoteReceiver.h
    INoteSource.cpp
    INoteSource.h
    IPatchable.h
    IPollable.h
    IPulseReceiver.cpp
    IPulseReceiver.h
    IUIControl.cpp
    IUIControl.h
    IVoiceParams.h
    InputChannel.cpp
    InputChannel.h
    Inverter.cpp
    Inverter.h
    JumpBlender.cpp
    JumpBlender.h
    KarplusStrong.cpp
    KarplusStrong.h
    KarplusStrongVoice.cpp
    KarplusStrongVoice.h
    KeyboardDisplay.cpp
    KeyboardDisplay.h
    Kicker.cpp
    Kicker.h
    LFO.cpp
    LFO.h
    LFOController.cpp
    LFOController.h
    LaunchpadInterpreter.cpp
    LaunchpadInterpreter.h
    LaunchpadKeyboard.cpp
    LaunchpadKeyboard.h
    LaunchpadNoteDisplayer.cpp
    LaunchpadNoteDisplayer.h
    LinkwitzRileyFilter.cpp
    LinkwitzRileyFilter.h
    LinnstrumentControl.cpp
    LinnstrumentControl.h
    Lissajous.cpp
    Lissajous.h
    LiveGranulator.cpp
    LiveGranulator.h
    LocationZoomer.cpp
    LocationZoomer.h
    LockFreeQueue.h
    LoopStorer.cpp
    LoopStorer.h
    Looper.cpp
    Looper.h
    LooperGranulator.cpp
    LooperGranulator.h
    LooperRecorder.cpp
    LooperRecorder.h
    M185Sequencer.cpp
    M185Sequencer.h
    MPESmoother.cpp
    MPESmoother.h
    MPETweaker.cpp
    MPETweaker.h
    MacroSlider.cpp
    MacroSlider.h
    Main.cpp
    MainComponent.cpp
    MathUtils.cpp
    MathUtils.h
    Metronome.cpp
    Metronome.h
    MidiCapturer.cpp
    MidiCapturer.h
    MidiClockIn.cpp
    MidiClockIn.h
    MidiClockOut.cpp
    MidiClockOut.h
    MidiControlChange.cpp
    MidiControlChange.h
    MidiController.cpp
    MidiController.h
    MidiDevice.cpp
    MidiDevice.h
    MidiOutput.cpp
    MidiOutput.h
    MidiReader.cpp
    MidiReader.h
    Minimap.cpp
    Minimap.h
    ModWheel.cpp
    ModWheel.h
    ModWheelToCV.cpp
    ModWheelToCV.h
    ModularSynth.cpp
    ModularSynth.h
    ModulationChain.cpp
    ModulationChain.h
    ModulationVisualizer.cpp
    ModulationVisualizer.h
    ModulatorAccum.cpp
    ModulatorAccum.h
    ModulatorAdd.cpp
    ModulatorAdd.h
    ModulatorAddCentered.cpp
    ModulatorAddCentered.h
    BoundsToPulse.cpp
    BoundsToPulse.h
    ModulatorCurve.cpp
    ModulatorCurve.h
    ModulatorExpression.cpp
    ModulatorExpression.h
    ModulatorGravity.cpp
    ModulatorGravity.h
    ModulatorMult.cpp
    ModulatorMult.h
    ModulatorSmoother.cpp
    ModulatorSmoother.h
    ModulatorSubtract.cpp
    ModulatorSubtract.h
    ModuleContainer.cpp
    ModuleContainer.h
    ModuleFactory.cpp
    ModuleFactory.h
    ModuleSaveData.cpp
    ModuleSaveData.h
    ModuleSaveDataPanel.cpp
    ModuleSaveDataPanel.h
    ModwheelToPressure.cpp
    ModwheelToPressure.h
    ModwheelToVibrato.cpp
    ModwheelToVibrato.h
    Monome.cpp
    Monome.h
    Monophonify.cpp
    Monophonify.h
    MultiBandTracker.cpp
    MultiBandTracker.h
    MultibandCompressor.cpp
    MultibandCompressor.h
    MultitapDelay.cpp
    MultitapDelay.h
    MultitrackRecorder.cpp
    MultitrackRecorder.h
    Muter.cpp
    Muter.h
    NamedMutex.cpp
    NamedMutex.h
    Neighborhooder.cpp
    Neighborhooder.h
    NoiseEffect.cpp
    NoiseEffect.h
    NoteCanvas.cpp
    NoteCanvas.h
    NoteChainNode.cpp
    NoteChainNode.h
    NoteChance.cpp
    NoteChance.h
    NoteCounter.cpp
    NoteCounter.h
    NoteCreator.cpp
    NoteCreator.h
    NoteDelayer.cpp
    NoteDelayer.h
    NoteDisplayer.cpp
    NoteDisplayer.h
    NoteEcho.cpp
    NoteEcho.h
    NoteEffectBase.h
    NoteExpressionRouter.cpp
    NoteExpressionRouter.h
    NoteFilter.cpp
    NoteFilter.h
    NoteFlusher.cpp
    NoteFlusher.h
    NoteGate.cpp
    NoteGate.h
    NoteHocket.cpp
    NoteHocket.h
    NoteHumanizer.cpp
    NoteHumanizer.h
    NoteLatch.cpp
    NoteLatch.h
    NoteLooper.cpp
    NoteLooper.h
    NoteOctaver.cpp
    NoteOctaver.h
    NoteOutputQueue.cpp
    NoteOutputQueue.h
    NotePanAlternator.cpp
    NotePanAlternator.h
    NotePanRandom.cpp
    NotePanRandom.h
    NotePanner.cpp
    NotePanner.h
    NoteQuantizer.cpp
    NoteQuantizer.h
    NoteRangeFilter.cpp
    NoteRangeFilter.h
    NoteRatchet.cpp
    NoteRatchet.h
    NoteRouter.cpp
    NoteRouter.h
    NoteSinger.cpp
    NoteSinger.h
    NoteSorter.cpp
    NoteSorter.h
    NoteStepSequencer.cpp
    NoteStepSequencer.h
    NoteStepper.cpp
    NoteStepper.h
    NoteStreamDisplay.cpp
    NoteStreamDisplay.h
    NoteStrummer.cpp
    NoteStrummer.h
    NoteSustain.cpp
    NoteSustain.h
    NoteTable.cpp
    NoteTable.h
    NoteToFreq.cpp
    NoteToFreq.h
    NoteToMs.cpp
    NoteToMs.h
    NoteToPulse.cpp
    NoteToPulse.h
    NoteToggle.cpp
    NoteToggle.h
    NoteTransformer.cpp
    NoteTransformer.h
    NoteVibrato.cpp
    NoteVibrato.h
    OSCOutput.cpp
    OSCOutput.h
    OpenFrameworksPort.cpp
    OpenFrameworksPort.h
    OscController.cpp
    OscController.h
    Oscillator.cpp
    Oscillator.h
    OutputChannel.cpp
    OutputChannel.h
    PSMoveController.cpp
    PSMoveController.h
    PSMoveMgr.cpp
    PSMoveMgr.h
    PanicButton.cpp
    PanicButton.h
    Panner.cpp
    Panner.h
    PatchCable.cpp
    PatchCable.h
    PatchCableSource.cpp
    PatchCableSource.h
    PeakTracker.cpp
    PeakTracker.h
    PerformanceTimer.cpp
    PerformanceTimer.h
    PerlinNoise.cpp
    PerlinNoise.h
    PitchBender.cpp
    PitchBender.h
    PitchChorus.cpp
    PitchChorus.h
    PitchDetector.cpp
    PitchDetector.h
    PitchDive.cpp
    PitchDive.h
    PitchPanner.cpp
    PitchPanner.h
    PitchRemap.cpp
    PitchRemap.h
    PitchSetter.cpp
    PitchSetter.h
    PitchShiftEffect.cpp
    PitchShiftEffect.h
    PitchShifter.cpp
    PitchShifter.h
    PitchToCV.cpp
    PitchToCV.h
    PitchToSpeed.cpp
    PitchToSpeed.h
    PlaySequencer.cpp
    PlaySequencer.h
    PolyphonyMgr.cpp
    PolyphonyMgr.h
    Polyrhythms.cpp
    Polyrhythms.h
    Prefab.cpp
    Prefab.h
    Pressure.cpp
    Pressure.h
    PressureToCV.cpp
    PressureToCV.h
    PressureToModwheel.cpp
    PressureToModwheel.h
    PressureToVibrato.cpp
    PressureToVibrato.h
    PreviousNote.cpp
    PreviousNote.h
    Producer.cpp
    Producer.h
    Profiler.cpp
    Profiler.h
    PulseButton.cpp
    PulseButton.h
    PulseChance.cpp
    PulseChance.h
    PulseDelayer.cpp
    PulseDelayer.h
    PulseDisplayer.cpp
    PulseDisplayer.h
    PulseFlag.cpp
    PulseFlag.h
    PulseGate.cpp
    PulseGate.h
    PulseHocket.cpp
    PulseHocket.h
    PulseSequence.cpp
    PulseSequence.h
    PulseTrain.cpp
    PulseTrain.h
    Pulser.cpp
    Pulser.h
    Pumper.cpp
    Pumper.h
    Push2Control.cpp
    Push2Control.h
    QuickSpawnMenu.cpp
    QuickSpawnMenu.h
    RadioButton.cpp
    RadioButton.h
    RadioSequencer.cpp
    RadioSequencer.h
    Ramp.cpp
    Ramp.h
    Ramper.cpp
    Ramper.h
    RandomNoteGenerator.cpp
    RandomNoteGenerator.h
    Razor.cpp
    Razor.h
    Rewriter.cpp
    Rewriter.h
    RingModulator.cpp
    RingModulator.h
    RollingBuffer.cpp
    RollingBuffer.h
    Sample.cpp
    Sample.h
    SampleBrowser.cpp
    SampleBrowser.h
    SampleCanvas.cpp
    SampleCanvas.h
    SampleCapturer.cpp
    SampleCapturer.h
    SampleDrawer.cpp
    SampleDrawer.h
    SampleFinder.cpp
    SampleFinder.h
    SampleLayerer.cpp
    SampleLayerer.h
    SamplePlayer.cpp
    SamplePlayer.h
    SampleVoice.cpp
    SampleVoice.h
    Sampler.cpp
    Sampler.h
    SamplerGrid.cpp
    SamplerGrid.h
    Scale.cpp
    Scale.h
    ScaleDegree.cpp
    ScaleDegree.h

=== libs/CMakeLists.txt ===
add_subdirectory(exprtk EXCLUDE_FROM_ALL)
add_subdirectory(freeverb EXCLUDE_FROM_ALL)
if(NOT BESPOKE_SYSTEM_JSONCPP)
  add_subdirectory(json EXCLUDE_FROM_ALL)
  message(STATUS "Using bundled jsoncpp")
else()
  include(FindPkgConfig)
  pkg_search_module(json REQUIRED jsoncpp)
  message(STATUS "Using system provided jsoncpp")
endif()
add_subdirectory(leathers EXCLUDE_FROM_ALL)
add_subdirectory(nanovg EXCLUDE_FROM_ALL)
add_subdirectory(oddsound-mts EXCLUDE_FROM_ALL)
add_subdirectory(psmove EXCLUDE_FROM_ALL)
add_subdirectory(push2 EXCLUDE_FROM_ALL)
add_subdirectory(readerwriterqueue EXCLUDE_FROM_ALL)

set(PYBIND11_NOPYTHON TRUE)
if(NOT BESPOKE_SYSTEM_PYBIND11)
  message(STATUS "Using bundled pybind11")
  add_subdirectory(pybind11 EXCLUDE_FROM_ALL)
else()
  message(STATUS "Using system installed pybind11")
  include(FindPkgConfig)
  find_package(pybind11 COMPONENTS REQUIRED)
endif()
add_library(bespoke_pybind11_wrapper INTERFACE)
target_compile_definitions(bespoke_pybind11_wrapper INTERFACE PYBIND11_EXPORT=)
target_link_libraries(bespoke_pybind11_wrapper INTERFACE pybind11::pybind11)
add_library(bespoke::pybind11 ALIAS bespoke_pybind11_wrapper)

if(NOT BESPOKE_SYSTEM_TUNING_LIBRARY)
  add_subdirectory(tuning-library EXCLUDE_FROM_ALL)
  message(STATUS "Using bundled tuning-library")
else()
  find_file(TUNING_LIB_TUNINGS NAMES Tunings.h PATHS /usr/local/include /usr/include REQUIRED)
  find_file(TUNING_LIB_TUNINGS_IMPL NAMES TuningsImpl.h PATHS /usr/local/include /usr/include REQUIRED)
  message(STATUS "Using system provided tuning-library")
endif()
add_subdirectory(xwax EXCLUDE_FROM_ALL)

=== libs/exprtk/CMakeLists.txt ===
add_library(exprtk INTERFACE)
target_include_directories(exprtk INTERFACE include)
add_library(bespoke::exprtk ALIAS exprtk)

=== libs/push2/CMakeLists.txt ===
project(push2)

set(DOC_STRING "Enable Ableton Push 2 support. When off, the push2control module is present but non-functional.")
option(BESPOKE_PUSH2_SUPPORT "${DOC_STRING}" ON)

add_library(${PROJECT_NAME}
    JuceToPush2DisplayBridge.cpp
    Push2-Display.cpp
    Push2-Display.h
    Push2-UsbCommunicator.h
    Result.cpp
    include/push2/JuceToPush2DisplayBridge.h
    include/push2/Macros.h
    include/push2/Push2-Bitmap.h
    include/push2/Result.h
    )

if(BESPOKE_PUSH2_SUPPORT)
    # FIXME: The code currently assumes that WIN32 == MSVC and will fail to build
    # on MinGW, so we use the system libusb on there. This is the best option for
    # native builds anyway, but for cross we should build libusb for convenience.
    if(APPLE OR MSVC)
        target_sources(${PROJECT_NAME} PRIVATE
            modules/libusb/core.c
            modules/libusb/descriptor.c
            modules/libusb/hotplug.c
            modules/libusb/io.c
            modules/libusb/strerror.c
            modules/libusb/sync.c
            )
        target_include_directories(${PROJECT_NAME} PRIVATE
            libusb
            modules/libusb
            )
    endif()

    if(APPLE)
        target_sources(${PROJECT_NAME} PRIVATE
            modules/libusb/os/darwin_usb.c
            modules/libusb/os/poll_posix.c
            modules/libusb/os/threads_posix.c
            )
        target_compile_definitions(${PROJECT_NAME} PRIVATE OBJC_SILENCE_GC_DEPRECATIONS=1)
    elseif(MSVC)
        target_sources(${PROJECT_NAME} PRIVATE
            modules/libusb/os/poll_windows.c
            modules/libusb/os/threads_windows.c
            modules/libusb/os/windows_winusb.c
            modules/libusb/os/windows_nt_common.c
            )
        target_compile_definitions(${PROJECT_NAME} PRIVATE
            HAVE_STRUCT_TIMESPEC
            THREADS_WINDOWS
            )
    else()
        find_package(PkgConfig)
        pkg_check_modules(LIBUSB libusb-1.0)
        if(NOT LIBUSB_FOUND)
            message(WARNING "libusb not found, disabling Ableton Push 2 support")
            set(BESPOKE_PUSH2_SUPPORT OFF CACHE BOOL "${DOC_STRING}" FORCE)
        endif()
        target_include_directories(${PROJECT_NAME} PRIVATE ${LIBUSB_INCLUDE_DIRS})
        target_link_libraries(${PROJECT_NAME} PRIVATE ${LIBUSB_LIBRARIES})
    endif()
endif()

# Gotta recheck in case it was vetoed above
if(BESPOKE_PUSH2_SUPPORT)
    target_sources(${PROJECT_NAME} PRIVATE Push2-Usb-Communicator.cpp)
    message(STATUS "Ableton Push 2 support enabled")
else()
    message(STATUS "Ableton Push 2 support disabled")
endif()

target_compile_definitions(${PROJECT_NAME} PRIVATE BESPOKE_PUSH2_SUPPORT=$<BOOL:${BESPOKE_PUSH2_SUPPORT}>)
target_include_directories(${PROJECT_NAME} PUBLIC include)
add_library(bespoke::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

=== libs/xwax/CMakeLists.txt ===
project(xwax VERSION 0.0.0 LANGUAGES CXX)

add_library(${PROJECT_NAME}
        src/lut.c
        src/timecoder.c
        )

# This means clients have to say "include xwax/foo" but internally we say "include foo"
target_include_directories(${PROJECT_NAME} PUBLIC .)
target_include_directories(${PROJECT_NAME} PRIVATE xwax)

if(WIN32)
  target_compile_definitions(${PROJECT_NAME} PRIVATE BESPOKE_WINDOWS=1)
endif()

add_library(bespoke::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

=== debian/changelog ===
bespokesynth (1.2.1+dfsg-4) unstable; urgency=medium

  * Replace adjust-json.patch with a forwarded PR.
  * Add patch to fix reproducibility issues.
  * Set upstream metadata fields: Repository.

 -- Andrius Merkys <merkys@debian.org>  Wed, 22 Nov 2023 01:18:38 -0500

bespokesynth (1.2.1+dfsg-3) unstable; urgency=medium

  * Drop unused system-ableton.patch.

 -- Andrius Merkys <merkys@debian.org>  Sun, 12 Nov 2023 02:52:14 -0500

bespokesynth (1.2.1+dfsg-2) unstable; urgency=medium

  * Add license statements for Source/PitchShifter.cpp and
    libs/nanovg/nanovg/fontstash.h.
  * Apply https://github.com/BespokeSynth/BespokeSynth/pull/1397 instead of a
    patch to locate system-provided AbletonLink.
  * Drop no longer needed patches.

 -- Andrius Merkys <merkys@debian.org>  Thu, 09 Nov 2023 05:07:26 -0500

bespokesynth (1.2.1+dfsg-1) unstable; urgency=medium

  * Initial release. (Closes: #1025206)

 -- Andrius Merkys <merkys@debian.org>  Wed, 18 Oct 2023 03:10:22 -0400

=== debian/control ===
--- 
+++ 
@@ -1,8 +1,7 @@
 Source: bespokesynth
 Section: sound
 Priority: optional
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
+Maintainer: Debian Multimedia Maintainers <debian-multimedia@lists.debian.org>
 Uploaders:
  Andrius Merkys <merkys@debian.org>,
 Rules-Requires-Root: no

## bespokesynth 1.3.0%2Bdfsg

=== libs/CMakeLists.txt ===
--- 
+++ 
@@ -3,10 +3,6 @@
 if(NOT BESPOKE_SYSTEM_JSONCPP)
   add_subdirectory(json EXCLUDE_FROM_ALL)
   message(STATUS "Using bundled jsoncpp")
-else()
-  include(FindPkgConfig)
-  pkg_search_module(json REQUIRED jsoncpp)
-  message(STATUS "Using system provided jsoncpp")
 endif()
 add_subdirectory(leathers EXCLUDE_FROM_ALL)
 add_subdirectory(nanovg EXCLUDE_FROM_ALL)

=== debian/watch ===
version=4
opts="filenamemangle=s%(?:.*?)?v?@ANY_VERSION@(@ARCHIVE_EXT@)%@PACKAGE@-$1$2%,repack,repacksuffix=+dfsg,dversionmangle=auto" \
 https://github.com/BespokeSynth/BespokeSynth/tags \
 (?:.*?/)?v?@ANY_VERSION@@ARCHIVE_EXT@

## bespokesynth 1.3.0+dfsg

=== CMakeLists.txt ===
--- 
+++ 
@@ -15,6 +15,7 @@
 option(BESPOKE_SYSTEM_PYBIND11 "Use a system installation of pybind11" OFF)
 option(BESPOKE_SYSTEM_JSONCPP "Use system-wide installation of jsoncpp" OFF)
 option(BESPOKE_SYSTEM_TUNING_LIBRARY "Use system installation of tuning-library" OFF)
+option(BESPOKE_SYSTEM_ABLETONLINK "Use system installation of abletonlink" OFF)
 option(BESPOKE_USE_ASAN "Build with ASAN" OFF)
 
 # Global CMake options
@@ -23,13 +24,13 @@
 set(CMAKE_CXX_STANDARD 17)
 set(CMAKE_MSVC_RUNTIME_LIBRARY "MultiThreaded$<$<CONFIG:Debug>:Debug>")
 set_property(DIRECTORY "${CMAKE_CURRENT_SOURCE_DIR}" PROPERTY VS_STARTUP_PROJECT BespokeSynth)
-set(CMAKE_OSX_DEPLOYMENT_TARGET 10.11 CACHE STRING "Minimum macOS version")
+set(CMAKE_OSX_DEPLOYMENT_TARGET 10.13 CACHE STRING "Minimum macOS version")
 set(CMAKE_POSITION_INDEPENDENT_CODE ON)
 if (NOT CMAKE_BUILD_TYPE)
     set(CMAKE_BUILD_TYPE "Release" CACHE STRING "" FORCE)
 endif ()
 
-project(BespokeSynth VERSION 1.2.1 LANGUAGES C CXX ASM)
+project(BespokeSynth VERSION 1.3.0 LANGUAGES C CXX ASM)
 
 message(STATUS "Build Type: ${CMAKE_BUILD_TYPE}")
 math(EXPR BESPOKE_BITNESS "${CMAKE_SIZEOF_VOID_P} * 8" OUTPUT_FORMAT DECIMAL)
@@ -96,6 +97,12 @@
   endif()
 endif()
 
+if(BESPOKE_SYSTEM_JSONCPP)
+    find_package(PkgConfig REQUIRED)
+    pkg_check_modules(JSONCPP REQUIRED jsoncpp)
+    include_directories(${JSONCPP_INCLUDE_DIRS})
+endif()
+
 if (BESPOKE_VST2_SDK_LOCATION)
     juce_set_vst2_sdk_path(${BESPOKE_VST2_SDK_LOCATION})
     message(STATUS "Enabling VST2 - caution, non FOSS build")

=== Source/CMakeLists.txt ===
--- 
+++ 
@@ -1,6 +1,10 @@
 include(cmake/lib.cmake)
 include(cmake/versiontools.cmake)
-include(../libs/ableton-link/AbletonLinkConfig.cmake)
+if(BESPOKE_SYSTEM_ABLETONLINK)
+    find_package(AbletonLink NAMES AbletonLink ableton-link link REQUIRED)
+else()
+    include(../libs/ableton-link/AbletonLinkConfig.cmake)
+endif()
 
 juce_add_gui_app(BespokeSynth
     PRODUCT_NAME BespokeSynth
@@ -16,6 +20,19 @@
     )
 
 bespoke_buildtime_version_info(BespokeSynth)
+
+if(MSVC)
+    if(BESPOKE_WERROR)
+        target_compile_options(BespokeSynth PRIVATE /WX)
+    endif()
+else()
+    if (APPLE)
+        target_compile_options(BespokeSynth PRIVATE -Wshorten-64-to-32)
+    endif()
+    if(BESPOKE_WERROR)
+        target_compile_options(BespokeSynth PRIVATE -Werror)
+    endif()
+endif()
 
 target_sources(BespokeSynth PRIVATE
     ADSR.cpp
@@ -38,6 +55,8 @@
     AudioRouter.h
     AudioSend.cpp
     AudioSend.h
+    AudioSplitter.cpp
+    AudioSplitter.h
     AudioToCV.cpp
     AudioToCV.h
     AudioToPulse.cpp
@@ -104,6 +123,8 @@
     CommentDisplay.h
     Compressor.cpp
     Compressor.h
+    ControlRecorder.cpp
+    ControlRecorder.h
     ControlSequencer.cpp
     ControlSequencer.h
     ControlTactileFeedback.cpp
@@ -114,6 +135,8 @@
     Curve.h
     CurveLooper.cpp
     CurveLooper.h
+    DataProvider.cpp
+    DataProvider.h
     DCOffset.cpp
     DCOffset.h
     DCRemoverEffect.cpp
@@ -124,6 +147,10 @@
     DelayEffect.h
     DistortionEffect.cpp
     DistortionEffect.h
+    DotGrid.cpp
+    DotGrid.h
+    DotSequencer.cpp
+    DotSequencer.h
     DropdownList.cpp
     DropdownList.h
     DrumPlayer.cpp
@@ -144,6 +171,8 @@
     EnvelopeEditor.h
     EnvelopeModulator.cpp
     EnvelopeModulator.h
+    EuclideanSequencer.cpp
+    EuclideanSequencer.h
     EventCanvas.cpp
     EventCanvas.h
     FFT.cpp
@@ -239,6 +268,8 @@
     KeyboardDisplay.h
     Kicker.cpp
     Kicker.h
+    LabelDisplay.cpp
+    LabelDisplay.h
     LFO.cpp
     LFO.h
     LFOController.cpp
@@ -249,6 +280,8 @@
     LaunchpadKeyboard.h
     LaunchpadNoteDisplayer.cpp
     LaunchpadNoteDisplayer.h
+    LevelMeterDisplay.cpp
+    LevelMeterDisplay.h
     LinkwitzRileyFilter.cpp
     LinkwitzRileyFilter.h
     LinnstrumentControl.cpp
@@ -491,6 +524,8 @@
     PitchToCV.h
     PitchToSpeed.cpp
     PitchToSpeed.h
+    PitchToValue.cpp
+    PitchToValue.h
     PlaySequencer.cpp
     PlaySequencer.h
     PolyphonyMgr.cpp
@@ -527,6 +562,10 @@
     PulseGate.h
     PulseHocket.cpp
     PulseHocket.h
+    PulseLimit.cpp
+    PulseLimit.h
+    PulseRouter.cpp
+    PulseRouter.h
     PulseSequence.cpp
     PulseSequence.h
     PulseTrain.cpp
@@ -536,50 +575,3 @@
     Pumper.cpp
     Pumper.h
     Push2Control.cpp
-    Push2Control.h
-    QuickSpawnMenu.cpp
-    QuickSpawnMenu.h
-    RadioButton.cpp
-    RadioButton.h
-    RadioSequencer.cpp
-    RadioSequencer.h
-    Ramp.cpp
-    Ramp.h
-    Ramper.cpp
-    Ramper.h
-    RandomNoteGenerator.cpp
-    RandomNoteGenerator.h
-    Razor.cpp
-    Razor.h
-    Rewriter.cpp
-    Rewriter.h
-    RingModulator.cpp
-    RingModulator.h
-    RollingBuffer.cpp
-    RollingBuffer.h
-    Sample.cpp
-    Sample.h
-    SampleBrowser.cpp
-    SampleBrowser.h
-    SampleCanvas.cpp
-    SampleCanvas.h
-    SampleCapturer.cpp
-    SampleCapturer.h
-    SampleDrawer.cpp
-    SampleDrawer.h
-    SampleFinder.cpp
-    SampleFinder.h
-    SampleLayerer.cpp
-    SampleLayerer.h
-    SamplePlayer.cpp
-    SamplePlayer.h
-    SampleVoice.cpp
-    SampleVoice.h
-    Sampler.cpp
-    Sampler.h
-    SamplerGrid.cpp
-    SamplerGrid.h
-    Scale.cpp
-    Scale.h
-    ScaleDegree.cpp
-    ScaleDegree.h

=== libs/freeverb/CMakeLists.txt ===
project(freeverb VERSION 0.0.0 LANGUAGES CXX)

add_library(${PROJECT_NAME}
        src/allpass.cpp
        src/comb.cpp
        src/revmodel.cpp
        )

# This means external code says include freeberb/blah but internal includes blah
target_include_directories(${PROJECT_NAME} PUBLIC .)
target_include_directories(${PROJECT_NAME} PRIVATE freeverb)

add_library(bespoke::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

=== libs/oddsound-mts/CMakeLists.txt ===
project(oddsound-mts VERSION 0.0.0 LANGUAGES CXX)

add_library(${PROJECT_NAME}
      MTS-ESP/Client/libMTSClient.cpp
)

target_include_directories(${PROJECT_NAME} PUBLIC MTS-ESP/Client)
target_link_libraries(${PROJECT_NAME} PRIVATE ${CMAKE_DL_LIBS})
add_library(surge::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

=== libs/psmove/CMakeLists.txt ===
project(psmove)

set(DOC_STRING "Enable PlayStation Move support (currently macOS only)")
option(BESPOKE_PSMOVE_SUPPORT "${DOC_STRING}" ${APPLE})

add_library(${PROJECT_NAME}
    hidapi.h
    include/psmove/psmove.h
    )

if(BESPOKE_PSMOVE_SUPPORT)
    string(TOLOWER "${CMAKE_SYSTEM_NAME}" SYSNAME)
    if(EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/hid_${SYSNAME}.c")
        target_sources(${PROJECT_NAME} PRIVATE "hid_${SYSNAME}.c")
    else()
        message(WARNING "No HID backend for target OS \"${CMAKE_SYSTEM_NAME}\", disabling PlayStation Move support")
        set(BESPOKE_PSMOVE_SUPPORT OFF CACHE BOOL "${DOC_STRING}" FORCE)
    endif()
endif()

if(BESPOKE_PSMOVE_SUPPORT)
    message(STATUS "PlayStation Move support enabled")
    target_sources(${PROJECT_NAME} PRIVATE psmove.c)
else()
    message(STATUS "PlayStation Move support disabled")
    target_sources(${PROJECT_NAME} PRIVATE psmove_dummy.c)
endif()

target_include_directories(${PROJECT_NAME}
    PRIVATE ${CMAKE_CURRENT_SOURCE_DIR}
    PUBLIC include
    )
add_library(bespoke::${PROJECT_NAME} ALIAS ${PROJECT_NAME})

=== debian/changelog ===
bespokesynth (1.3.0+dfsg-2build1) plucky; urgency=medium

  * No-change rebuild for flac.

 -- Simon Quigley <tsimonq2@ubuntu.com>  Fri, 14 Mar 2025 22:35:44 -0500

bespokesynth (1.3.0+dfsg-2) unstable; urgency=medium

  * Build-depend on libexprtk-dev instead of libmrpt-expr-dev.

 -- Andrius Merkys <merkys@debian.org>  Mon, 27 Jan 2025 02:33:32 -0500

bespokesynth (1.3.0+dfsg-1) unstable; urgency=medium

  * New upstream version 1.3.0+dfsg
  * Add versioned depends on juce-modules-source.
  * Use system-provided exprtk, build depend on libmrpt-expr-dev to get the
    missing exprtk.hpp.
  * Add debian/gbp.conf.

 -- Andrius Merkys <merkys@debian.org>  Mon, 23 Dec 2024 09:47:17 -0500

=== debian/control ===
--- 
+++ 
@@ -9,7 +9,8 @@
  ableton-link-dev,
  cmake,
  debhelper-compat (= 13),
- juce-modules-source,
+ juce-modules-source (>= 7.0.0),
+ libexprtk-dev,
  libjack-dev,
  libjsoncpp-dev,
  libmts-esp-dev,

=== debian/rules ===
#!/usr/bin/make -f

%:
	dh $@

override_dh_auto_configure:
	dh_auto_configure -- -DBESPOKE_SYSTEM_JUCE=ON -DBESPOKE_DEVENDORED_SYSTEM_JUCE=ON -DBESPOKE_SYSTEM_PYBIND11=ON -DBESPOKE_SYSTEM_JSONCPP=ON -DBESPOKE_SYSTEM_TUNING_LIBRARY=ON -DBESPOKE_SYSTEM_ABLETONLINK=ON
